;;;		     MASSACHUSETTS INSTITUTE OF TECHNOLOGY
;;;	   Department of Electrical Engineering and Computer Science
;;;	   6.001---Structure and Interpretation of Computer Programs
;;;			      Fall Semester, 1997
;;;				 Problem Set 1
;;;
;;;			    Code file PS1-HIDE.SCM

;;A HIDER is given the ends of an interval and a split-point, and returns
;;its choice of where to hide: the lower part or the upper part.

; The NAIVE HIDER always tries to pick the number 42.
(define (naive-hider low split-point high)
  (if (< 42 low)
      not-higher
      (if (< high 42)
	  higher
	  (if (< split-point 42)
	      higher
	      not-higher))))

;;The ELBOW-ROOM HIDER always chooses the larger part to hide in -- no
;;surprise here.
(define (elbow-room-hider low split-point high)
   (if (< (- high split-point) (inc (- split-point low)))
       not-higher
       higher))

;;Then there's the RANDOM-ANSWER HIDER.
(define (random-answer-hider low split-point high)
  (if (= (guess 0 1) 0)
      not-higher
      higher))


; The USER-HIDER asks the user what do to.
(define (user-hider low split-point high)
  (begin
    (newline)
    (display "The searcher knows the number is between ")
    (display low) (display " and ") (display high) (display ".")
    (newline)
    (display "Is your number higher than ") (display split-point)
    (display " (answer #t or #f:)?")
    (newline)
    (if (read)
        higher
        not-higher)))

; Whichever hider the variable HIDER is bound to is the one that will be
; used.  Initially, let HIDER be the NAIVE-HIDER. 
(define hider naive-hider)

