;;;		     MASSACHUSETTS INSTITUTE OF TECHNOLOGY
;;;	   Department of Electrical Engineering and Computer Science
;;;	   6.001---Structure and Interpretation of Computer Programs
;;;			      Fall Semester, 1997
;;;				 Problem Set 1
;;;
;;;			  Code file PS1-PLAY.SCM


;;To play a search/hide game on an interval from 0 to n inclusive, the
;;searcher is given the interval bounds, initially 0 and n, and chooses
;;a split-point.  The interval bounds and the split point are then given
;;to the hider, who returns a choice -- "higher" or "not-higher" -- of where
;;to hide.  The searcher is told the choice, calculates the new bounds,
;;and the cycle repeats until the interval has shrunk to a single point
;;-- where hider must be.  The procedure PLAY carries out this process.
;;The expression
;;                               (PLAY N)
;;returns the total number of questions the searcher asked in a game
;;before pinning down the hider.

(define (play n)
  (play-loop 0 n 0))

(define (play-loop low high num-questions)
  (if (= low high)
      num-questions
      (ask-hider (searcher low high) low high num-questions)))

(define (ask-hider split-point low high num-questions)
  (finish-round (hider low split-point high)
		split-point
		low
		high
		num-questions))

(define (finish-round response split-point low high num-questions)
  (if (higher? response)
      (play-loop (inc split-point) high (inc num-questions))
      (play-loop low split-point (inc num-questions))))


(define higher #t)
(define not-higher #f)

(define (higher? response)
  response)

;the number of questions asked by the binary searcher
(define (binary-vs-elbow-questions n)
  (if (= n 0)
      0
      (+ 1 (binary-vs-elbow-questions (floor (/ n 2))))))
;which, by the way, is the same as ceiling(log_2 n).