;;;		     MASSACHUSETTS INSTITUTE OF TECHNOLOGY
;;;	   Department of Electrical Engineering and Computer Science
;;;	   6.001---Structure and Interpretation of Computer Programs
;;;			      Fall Semester, 1997
;;;				 Problem Set 1
;;;
;;;			    Code file PS1-SRCH.SCM

;; A SEARCHER is given the endpoints of the interval to search
;; (note that the endpoints themselves are considered to be in
;; the interval), and returns a "split-point" that is greater
;; than or equal to the lower endpoint, and less than the higher
;; endpoint.  The interpretation is that the searcher wishes
;; to ask the question "Is the number greater than <split-point>?"

;; The RANDOM SEARCHER hasn't a clue and simply guesses at random, using
;; the special GUESS procedure provided in this problem set.  GUESS
;; takes inputs defining a range in which numbers may lie, and generates
;; at random an integer that lies within that range.
(define (random-searcher low high)
  (guess low (dec high)))

;The IMPLACABLE SEARCHER works through the interval by
;searching through the interval from low to high.
(define (implacable-searcher low high)
  low)

;; The BINARY SEARCHER splits the interval in the middle -- this
;; is the optimal way to search in this game.
(define (binary-searcher low high)
  (floor (+ low (/ (- high low) 2))))

; The USER SEARCHER asks the user what do to.
(define (user-searcher low high)
  (begin
    (newline)
    (display "The range is ")(display low)(display " to ")(display high)(display ".")
    (newline)
    (display "What is your guess?: ")
    (read)))

; Whichever searcher the variable SEARCHER is bound to is the one that will 
; be used.  Initially, let SEARCHER be the USER-SEARCHER. 
(define searcher user-searcher)



;;; Auxiliary procedure

;; GUESS takes inputs defining an interval range in which numbers may
;; lie and it generates an integer chosen at random within that range
;; (inclusive).

(define (guess low high)
    (+ low (random (+ 1 (- high low)))))
