;;;		     MASSACHUSETTS INSTITUTE OF TECHNOLOGY
;;;	   Department of Electrical Engineering and Computer Science
;;;	   6.001---Structure and Interpretation of Computer Programs
;;;			      Fall Semester, 1997
;;;				 Problem Set 1
;;;
;;;			  Code file PS1-TOUR.SCM



;; Procedure TOURNAMENT is given a number, TOURNAMENT-LENGTH, of games to
;; play, and the upper bound, N, on the initial game interval [0, N].
;; It prints out for each game:
;;               game no: <num>    game-length: <number of questions>
;; and at the end displays the mean and standard deviation of the
;; game lengths.  Since it prints out everything we want to know,
;; we leave unspecified what value it returns.

(define (tournament tournament-length n)
  (tournament-loop 0 0 0 tournament-length n))


;; TOURNAMENT-LOOP is the `helper' procedure which does the work for
;; TOURNAMENT.  Its GAME-NUM variable is used to track the game number,
;; SUM is the running sum of all the game lengths, and SUM-OF-SQ is
;; the sum of the squares of the game lengths.  These values are used
;; compute the mean and deviation of the game lengths when the tournament
;; is complete.


(define (tournament-loop game-num sum sum-of-sq tournament-length n)
  (if (= game-num tournament-length)    ;is play done?
      (begin                            ;play is done
        (newline) (newline)
        (display "The MEAN game length was ") (display (/ sum game-num)) (display ",")
        (display " with DEVIATION ")
        (display (deviation game-num sum sum-of-sq))
        (newline)
        "Tournament is over.")
      (display-outcome                  ;play is not done
       (play n)
       (inc game-num) sum sum-of-sq tournament-length n)))


(define (display-outcome
         game-length gnum-plus1 sum sum-of-sq tournament-length n)
  (begin
    (newline)
    (display "    ;;  game no: ") (display gnum-plus1)
    (display "  game-length: ") (display game-length)
    (tournament-loop gnum-plus1
		   (+ sum game-length)
		   (+ sum-of-sq (square game-length))
		   tournament-length
		   n)))


;; Note that TOURNAMENT-LOOP is defined simultaneously with the
;; procedure DISPLAY-OUTCOME.  These two procedures would obviously be
;; mutually tail-recursive, except for the call to the procedure PLAY
;; as an argument:
;         (display-outcome
;          (play n)
;          ...)
;; in the alternative clause of the IF in TOURNAMENT-LOOP above.  But
;; PLAY is clearly tail-recursive, so calling it preserves tail-recursiveness
;; and so TOURNAMENT-LOOP and hence TOURNAMENT really are tail-recursive.


;;;Auxiliary Procedures

;; The DEVIATION of a series of numbers can be computed by subtracting the
;; square of the mean of the numbers from the mean of the squares of the
;; numbers, and then taking the square root of the difference:

(define (deviation n sum sum-of-sq)
  (sqrt (- (/ sum-of-sq n) (square (/ sum n)))))


(define (square x) (* x x))
